## moonphase 0.5.0

=== CMakeLists.txt ===
#
# This file is part of moonphase.
# Copyright (C) 2014-2018 by Alan Wise <awisesoftware@gmail.com>.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# CMake minimum version.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

# Load user preferences.
INCLUDE("${CMAKE_SOURCE_DIR}/preferences.cmake" OPTIONAL)

# Default to Release build type. This needs to be before PROJECT().
IF(NOT DEFINED CMAKE_BUILD_TYPE)
  MESSAGE(WARNING "\nBuild type not set. Defaulting to \"Release\".")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Build type unset. Forced to \"Release\"." FORCE)
ENDIF()

# Options
INCLUDE(CMakeDependentOption)
OPTION(OPTION_MOONPHASE_USEDEBUGLOG "Enable debug logging." OFF)
OPTION(OPTION_MOONPHASE_USEMESSAGELOG "Enable message logging." OFF)
OPTION(OPTION_MOONPHASE_USEDEBUGTOOLS "Enable debugging tools." OFF)
CMAKE_DEPENDENT_OPTION(OPTION_MOONPHASE_USECCACHE "Enable ccache." OFF UNIX OFF)

# Project name.
PROJECT("Moon Phase")

# Project information.
SET(MOONPHASE_DISPLAYNAME "${PROJECT_NAME}")
STRING(TOLOWER "${PROJECT_NAME}" PROJECT_NAMELC)
STRING(REPLACE " " "" PROJECT_NAMELCNS "${PROJECT_NAMELC}")
SET(MOONPHASE_EXECUTABLENAME ${PROJECT_NAMELCNS})
SET(MOONPHASE_MAJORVERSION "0")                 # Overridable.
SET(MOONPHASE_MINORVERSION "4")                 # Overridable.
SET(MOONPHASE_PATCHVERSION "2")                 # Overridable.
SET(MOONPHASE_DESCRIPTION                       # Overridable.
    "Displays the phase of the moon in the system tray."
    " Additionally, a window and/or tool tip can be displayed that shows user"
    " configurable data"
    " about the moon (rise/set times, percent illumination, etc).")
STRING(REPLACE ";" "" MOONPHASE_DESCRIPTION "${MOONPHASE_DESCRIPTION}")
SET(MOONPHASE_OWNERNAME "Alan Wise")
SET(MOONPHASE_COPYRIGHTNOTICE "Copyright (C) 2014-2018 ${MOONPHASE_OWNERNAME}.")
SET(MOONPHASE_WEBSITE "https://moonphase.gitlab.com")
SET(MOONPHASE_LICENSE
    "License GPLv3: GNU GPL version 3 or later <http://www.gnu.org/licenses/>.")

# Convert license agreement to include file.
FILE(READ "${PROJECT_SOURCE_DIR}/documentation/license.txt" TEXT)
STRING(REGEX REPLACE "\"" "\\\\\"" ESCAPEQUOTES "${TEXT}")
STRING(REGEX REPLACE "\n" "\\\\n\"\n\"" CCODE "${ESCAPEQUOTES}")
SET(INCLUDETEXT "const char f_pLicenseAgreement[]=\n\"${CCODE}\";")
FILE(WRITE
    "${CMAKE_CURRENT_BINARY_DIR}/licenseagreement.h" "${INCLUDETEXT}")

# Convert change log to include file.
FILE(READ "${PROJECT_SOURCE_DIR}/documentation/changelog.txt" TEXT)
STRING(REGEX REPLACE "\"" "\\\\\"" ESCAPEQUOTES "${TEXT}")
STRING(REGEX REPLACE "\n" "\\\\n\"\n\"" CCODE "${ESCAPEQUOTES}")
SET(INCLUDETEXT "const char f_pChangeLog[]=\n\"${CCODE}\";")
FILE(WRITE
    "${CMAKE_CURRENT_BINARY_DIR}/changelog.h" "${INCLUDETEXT}")

# Additional compiler options and settings.
IF(${CMAKE_C_COMPILER_ID} STREQUAL GNU)
  SET(DEFINE_PREFIX -D)
  ADD_DEFINITIONS(${DEFINE_PREFIX}_GNU_SOURCE)
      # Need this define for certain prototypes.
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} \
      -ansi -Wall -Wextra -Wcast-qual -Wconversion -Wformat=2 -Wshadow \
      -Wstrict-overflow=5 -Wunused -std=c99")
      # >=c99 for wchar_t.
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} \
      -ansi -Wall -Wextra -Wcast-qual -Wconversion -Wformat=2 -Wshadow \
      -Wstrict-overflow=5 -Wunused -fvisibility=hidden")
  IF(NOT CMAKE_SYSTEM_NAME STREQUAL Darwin)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  ENDIF()
ELSEIF(${CMAKE_C_COMPILER_ID} STREQUAL MSVC)
  SET(DEFINE_PREFIX /D)
  ADD_DEFINITIONS(
      ${DEFINE_PREFIX}_CRT_SECURE_NO_WARNINGS
      ${DEFINE_PREFIX}_CRT_NONSTDC_NO_DEPRECATE
      ${DEFINE_PREFIX}_USE_MATH_DEFINES)
ELSE()
  MESSAGE(FATAL_ERROR
      "Unknown compiler configuration. CMakeLists.txt needs to be updated!")
ENDIF()

# ccache
IF(UNIX AND OPTION_MOONPHASE_USECCACHE)
  FIND_PROGRAM(CCACHE_EXECUTABLE ccache)
  MARK_AS_ADVANCED(CCACHE_EXECUTABLE)
  IF(CCACHE_EXECUTABLE)
    SET_PROPERTY(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_EXECUTABLE}")
    SET_PROPERTY(GLOBAL PROPERTY RULE_LAUNCH_LINK "${CCACHE_EXECUTABLE}")
  ENDIF()
ENDIF()

# Build environment.
IF(NOT UNIX AND NOT WIN32)
  MESSAGE(FATAL_ERROR
      "Unknown build configuration. CMakeLists.txt needs to be updated!")
ENDIF()

# If debug mode, set debug definition.
STRING(TOLOWER "${CMAKE_BUILD_TYPE}" BUILDTYPELC)
IF(${BUILDTYPELC} STREQUAL debug)
  ADD_DEFINITIONS(${DEFINE_PREFIX}DEBUG)
ENDIF()

# If release mode, set build release flag.
IF("${BUILDTYPELC}" STREQUAL "release")
  SET(BUILDRELEASEFLAG ON)
ELSE()
  SET(BUILDRELEASEFLAG OFF)
ENDIF()


#
# Include paths
#


#
# Sources
#


#
# Binaries
#


#
# Subdirectories
#

ADD_SUBDIRECTORY("awisetoolbox")
ADD_SUBDIRECTORY("qt")


#
# Installation
#


#
# CMakeLists.txt
#

=== awisetoolbox/CMakeLists.txt ===
#
# CMakeLists.txt
# Top level CMake makefile.
#

#
# This file is part of awisetoolbox.
# Copyright (C) 2008-2017 by Alan Wise (awisesoftware@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# CMake minimum version.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

# Load user preferences.
INCLUDE("${CMAKE_SOURCE_DIR}/preferences.cmake" OPTIONAL)

# Default to Release build type. This needs to be before PROJECT().
IF(NOT DEFINED CMAKE_BUILD_TYPE)
  MESSAGE(WARNING "\nBuild type not set. Defaulting to \"Release\".")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Build type unset. Forced to \"Release\"." FORCE)
ENDIF()

# Options
INCLUDE(CMakeDependentOption)
OPTION(OPTION_AWISETOOLBOX_USEDEBUGLOG "Enable debug logging." OFF)
OPTION(OPTION_AWISETOOLBOX_USEMESSAGELOG "Enable message logging." OFF)
OPTION(OPTION_AWISETOOLBOX_USEDEBUGTOOLS "Enable debugging tools." OFF)
CMAKE_DEPENDENT_OPTION(OPTION_AWISETOOLBOX_USECCACHE "Enable ccache." OFF UNIX OFF)

# Project name.
PROJECT("A.Wise Toolbox")

# Project information.
SET(AWISETOOLBOX_DISPLAYNAME "${PROJECT_NAME}")
STRING(TOLOWER "${PROJECT_NAME}" PROJECT_NAMELC)
STRING(REPLACE " " "" PROJECT_NAMELCNS "${PROJECT_NAMELC}")
STRING(REPLACE "." "" PROJECT_NAMELCNSNP "${PROJECT_NAMELCNS}")
SET(AWISETOOLBOX_BASENAME ${PROJECT_NAMELCNSNP})
SET(AWISETOOLBOX_MAJORVERSION "0")        # Overridable.
SET(AWISETOOLBOX_MINORVERSION "3")        # Overridable.
SET(AWISETOOLBOX_PATCHVERSION "0")        # Overridable.
SET(AWISETOOLBOX_DESCRIPTION              # Overridable.
    "A collection of code and data which can be used on multiple projects.")
STRING(REPLACE ";" "" AWISETOOLBOX_DESCRIPTION "${AWISETOOLBOX_DESCRIPTION}")
SET(AWISETOOLBOX_OWNERNAME "Alan Wise")
SET(AWISETOOLBOX_COPYRIGHTNOTICE "Copyright (C) 2008-2017 ${AWISETOOLBOX_OWNERNAME}.")
SET(AWISETOOLBOX_WEBSITE "https://gitlab.com/alanwise/awisetoolbox/")
SET(AWISETOOLBOX_LICENSE
    "License GPLv3: GNU GPL version 3 or later <http://www.gnu.org/licenses/>.")

# Additional compiler options and settings.
IF(${CMAKE_C_COMPILER_ID} STREQUAL GNU)
  SET(G_DEFINEPREFIX -D)
  ADD_DEFINITIONS(${G_DEFINEPREFIX}_GNU_SOURCE)
      # Need this define for certain prototypes.
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} \
      -ansi -Wall -Wextra -Wcast-qual -Wconversion -Wformat=2 -Wshadow \
      -Wstrict-overflow=5 -Wunused -std=c99")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} \
      -ansi -Wall -Wextra -Wcast-qual -Wconversion -Wformat=2 -Wshadow \
      -Wstrict-overflow=5 -Wunused")
  IF(NOT CMAKE_SYSTEM_NAME STREQUAL Darwin)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  ENDIF()
ELSEIF(${CMAKE_C_COMPILER_ID} STREQUAL MSVC)
  SET(G_DEFINEPREFIX /D)
  ADD_DEFINITIONS(
      ${G_DEFINEPREFIX}_CRT_SECURE_NO_WARNINGS
      ${G_DEFINEPREFIX}_CRT_NONSTDC_NO_DEPRECATE)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Wall /wd4710 /wd4711 /wd4820")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Wall /wd4710 /wd4711 /wd4820")
      # 4710/4711 - Don't care that a function isn't/is being inlined.
      # 4820 - Don't care about padding.
ELSE()
  MESSAGE(FATAL_ERROR
      "Unknown compiler configuration. CMakeLists.txt needs to be updated!")
ENDIF()

# Build environment.
IF(NOT UNIX AND NOT WIN32)
  MESSAGE(FATAL_ERROR
      "Unknown build configuration. CMakeLists.txt needs to be updated!")
ENDIF()

# If debug mode, set debug definition.
STRING(TOLOWER "${CMAKE_BUILD_TYPE}" BUILDTYPELC)
IF("${BUILDTYPELC}" STREQUAL "debug")
  ADD_DEFINITIONS(${G_DEFINEPREFIX}DEBUG)
ENDIF()

# Enable debug log, message log, and debug tools.
REMOVE_DEFINITIONS(
    ${G_DEFINEPREFIX}USE_DEBUGLOG
    ${G_DEFINEPREFIX}USE_MESSAGELOG
    ${G_DEFINEPREFIX}USE_DEBUGTOOLS)  # Remove the options set in other projects.
IF(OPTION_AWISETOOLBOX_USEDEBUGLOG)
  ADD_DEFINITIONS(${G_DEFINEPREFIX}USE_DEBUGLOG)
  SET(DOXYGEN_PREDEFINED "${DOXYGEN_PREDEFINED} USE_DEBUGLOG")
ENDIF()
IF(OPTION_AWISETOOLBOX_USEMESSAGELOG)
  ADD_DEFINITIONS(${G_DEFINEPREFIX}USE_MESSAGELOG)
  SET(DOXYGEN_PREDEFINED "${DOXYGEN_PREDEFINED} USE_MESSAGELOG")
ENDIF()
IF(OPTION_AWISETOOLBOX_USEDEBUGTOOLS)
  ADD_DEFINITIONS(${G_DEFINEPREFIX}USE_DEBUGTOOLS)
  SET(DOXYGEN_PREDEFINED "${DOXYGEN_PREDEFINED} USE_DEBUGTOOLS")
ENDIF()

# ccache.
IF(OPTION_AWISETOOLBOX_USECCACHE)
  # Find ccache if not previously found.
  IF(NOT CCACHE_EXECUTABLE)
    FIND_PROGRAM(CCACHE_EXECUTABLE ccache)
    MARK_AS_ADVANCED(CCACHE_EXECUTABLE)
  ENDIF()
  # Use ccache on awisetoolbox directories only.
  IF(CCACHE_EXECUTABLE)
    SET_PROPERTY(DIRECTORY PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_EXECUTABLE}")
    SET_PROPERTY(DIRECTORY PROPERTY RULE_LAUNCH_LINK "${CCACHE_EXECUTABLE}")
  ENDIF()
ENDIF()

# If release mode, set build release flag.
IF("${BUILDTYPELC}" STREQUAL "release")
  SET(G_RELEASEFLAG ON)
ELSE()
  SET(G_RELEASEFLAG OFF)
ENDIF()


#
# Include paths
#


#
# Sources
#


#
# Binaries
#


#
# Subdirectories
#

ADD_SUBDIRECTORY("generic/")
ADD_SUBDIRECTORY("qt/")


#
# Installation
#


#
# CMakeLists.txt
#

=== qt/CMakeLists.txt ===
#
# This file is part of moonphase.
# Copyright (C) 2014-2018 by Alan Wise <awisesoftware@gmail.com>.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#


#
# Include paths
#


#
# Sources
#


#
# Binaries
#


#
# Subdirectories
#

ADD_SUBDIRECTORY("moonphase-qt/")


#
# Installation
#


#
# CMakeLists.txt
#

=== awisetoolbox/generic/CMakeLists.txt ===
#
# CMakeLists.txt
# CMake makefile for the A.Wise Toolbox Generic library.
#

#
# This file is part of awisetoolbox.
# Copyright (C) 2008-2017 by Alan Wise (awisesoftware@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# Display name.
SET(DISPLAYNAME "Generic Library")

# Build information.
SET(LIBRARYNAME "${AWISETOOLBOX_BASENAME}generic")
SET(MAJORVERSION ${AWISETOOLBOX_MAJORVERSION})
SET(MINORVERSION ${AWISETOOLBOX_MINORVERSION})
SET(PATCHVERSION ${AWISETOOLBOX_PATCHVERSION})
SET(DESCRIPTION
    "A generic collection of code and data which can be used on"
    " multiple projects.")
STRING(REPLACE ";" "" DESCRIPTION "${DESCRIPTION}")

# Directories.
SET(CMAKE_DIR "${PROJECT_SOURCE_DIR}/generic/cmake/")
SET(SOURCES_DIR "${PROJECT_SOURCE_DIR}/generic/sources/")


#
# Include paths
#


#
# Sources
#

INCLUDE("cmake/library.cmake")
INCLUDE("cmake/documentation.cmake")
INCLUDE("cmake/test.cmake")


#
# Binaries
#


#
# Subdirectories
#


#
# Installation
#


#
# CMakeLists.txt
#

=== awisetoolbox/qt/CMakeLists.txt ===
#
# CMakeLists.txt
# CMake makefile for the A.Wise Toolbox Qt libraries.
#

#
# This file is part of awisetoolbox.
# Copyright (C) 2008-2017 by Alan Wise (awisesoftware@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#


#
# Include paths
#


#
# Sources
#


#
# Binaries
#


#
# Subdirectories
#

ADD_SUBDIRECTORY("designer/")
ADD_SUBDIRECTORY("utilities/")
ADD_SUBDIRECTORY("widgets/")


#
# Installation
#


#
# CMakeLists.txt
#

=== qt/moonphase-qt/CMakeLists.txt ===
#
# CMakeLists.txt
# CMake makefile for the Moon Phase Qt application.
#

#
# This file is part of moonphase.
# Copyright (C) 2014-2018 by Alan Wise <awisesoftware@gmail.com>.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


INCLUDE(ExternalProject)

SET(MOONPHASEQT_DISPLAYNAME "${MOONPHASE_DISPLAYNAME} (Qt)")

# Options.
OPTION(OPTION_MOONPHASE_BUILDMOONPHASEQT
    "Build the ${MOONPHASEQT_DISPLAYNAME} application." ON)
OPTION(OPTION_MOONPHASE_BUILDMOONPHASEQTDOCUMENTATION
    "Build the ${MOONPHASEQT_DISPLAYNAME} application documentation." OFF)


#
# Configuration
#

# Build information.
SET(MOONPHASEQT_EXECUTABLENAME "${MOONPHASE_EXECUTABLENAME}-qt")
STRING(REPLACE "-" "" MOONPHASEQT_EXECUTABLENAMEND "${MOONPHASEQT_EXECUTABLENAME}")
SET(MOONPHASEQT_MAJORVERSION ${MOONPHASE_MAJORVERSION})
SET(MOONPHASEQT_MINORVERSION ${MOONPHASE_MINORVERSION})
SET(MOONPHASEQT_PATCHVERSION ${MOONPHASE_PATCHVERSION})
SET(MOONPHASEQT_DESCRIPTION ${MOONPHASE_DESCRIPTION})

IF(OPTION_MOONPHASE_BUILDMOONPHASEQT)
  # Need Qt4.
  FIND_PACKAGE(Qt4 REQUIRED QtCore QtGui QtNetwork)
  INCLUDE(${QT_USE_FILE})
  # Create a configuration file.
  CONFIGURE_FILE(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in"
      "${CMAKE_CURRENT_BINARY_DIR}/config.h")
  # Create the desktop entry.
  IF(UNIX)
    CONFIGURE_FILE(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake/${MOONPHASEQT_EXECUTABLENAME}.desktop.in"
        "${CMAKE_CURRENT_BINARY_DIR}/${MOONPHASEQT_EXECUTABLENAME}.desktop")
  ENDIF()
  # Additional definitions.
  IF(MSVC)
    ADD_DEFINITIONS(${DEFINE_PREFIX}UNICODE)
        # Needed for qtsingleapplication (qlockedfile_win.cpp)
  ENDIF()
ENDIF()

IF(OPTION_MOONPHASE_BUILDMOONPHASEQTDOCUMENTATION)
  # Need Doxygen.
  FIND_PACKAGE(Doxygen REQUIRED)
  # Create the Doxygen file.
  CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/cmake/Doxyfile.in"
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${MOONPHASEQT_EXECUTABLENAME}")
ENDIF()


#
# Include paths
#

IF(OPTION_MOONPHASE_BUILDMOONPHASEQT)
  INCLUDE_DIRECTORIES(
      "${CMAKE_BINARY_DIR}/"
      "${CMAKE_CURRENT_BINARY_DIR}/"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources"
      "${CMAKE_BINARY_DIR}/awisetoolbox/qt/widgets/"
      "${CMAKE_BINARY_DIR}/awisetoolbox/qt/utilities/sources/"
      "${CMAKE_SOURCE_DIR}/awisetoolbox/qt/widgets/sources/"
      "${CMAKE_SOURCE_DIR}/awisetoolbox/qt/utilities/sources/"
      "${CMAKE_SOURCE_DIR}/qt/qt-solutions/qtsingleapplication/src/"
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/"
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/qwwbuttonlineedit/"
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/qwwcolorbutton/"
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/qwwfilechooser/")
ENDIF()


#
# Sources
#

IF(OPTION_MOONPHASE_BUILDMOONPHASEQT)
  INCLUDE("${CMAKE_SOURCE_DIR}/common/common.cmake")
  SET(MOONPHASEQT_SOURCES
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/${MOONPHASEQT_EXECUTABLENAMEND}.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/controlpaneldialog.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/drawframe.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationitem.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationitemoptions.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationoptionsdialog.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationpaneldialog.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/moonanimation.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/preferenceswidget.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/settings.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/../qt-solutions/qtsingleapplication/src/qtlocalpeer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/../qt-solutions/qtsingleapplication/src/qtsingleapplication.cpp")
  SET(MOONPHASEQT_HEADERS
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/controlpaneldialog.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationoptionsdialog.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationpaneldialog.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/preferenceswidget.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/../qt-solutions/qtsingleapplication/src/qtlocalpeer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/../qt-solutions/qtsingleapplication/src/qtsingleapplication.h")
  SET(MOONPHASEQT_FORMS
      "${CMAKE_CURRENT_SOURCE_DIR}/forms/controlpaneldialog.ui"
      "${CMAKE_CURRENT_SOURCE_DIR}/forms/informationoptionsdialog.ui"
      "${CMAKE_CURRENT_SOURCE_DIR}/forms/informationpaneldialog.ui"
      "${CMAKE_CURRENT_SOURCE_DIR}/forms/preferenceswidget.ui")
  SET(MOONPHASEQT_RESOURCES
      "${CMAKE_CURRENT_SOURCE_DIR}/resources/${MOONPHASEQT_EXECUTABLENAMEND}.qrc")
  QT4_WRAP_CPP(MOONPHASEQT_MOC ${MOONPHASEQT_HEADERS})
  QT4_WRAP_UI(MOONPHASEQT_UI ${MOONPHASEQT_FORMS})
  QT4_ADD_RESOURCES(MOONPHASEQT_QRC ${MOONPHASEQT_RESOURCES})
  SET(MOONPHASEQT_FILES
      ${MOONPHASEQT_SOURCES}
      ${MOONPHASEQT_MOC}
      ${MOONPHASEQT_UI}
      ${MOONPHASEQT_QRC})
  FILE(GLOB MOONPHASE_IMAGES "${CMAKE_SOURCE_DIR}/images/*")
  IF(WIN32)
    SET(MOONPHASEQT_FILES ${MOONPHASEQT_FILES}
        "${CMAKE_CURRENT_SOURCE_DIR}/resources/${MOONPHASEQT_EXECUTABLENAME}.rc")
  ELSEIF(APPLE)
    SET(MACOS_RESOURCES
        "${CMAKE_CURRENT_LIST_DIR}/resources/${MOONPHASEQT_EXECUTABLENAME}.icns"
        "${MOONPHASE_IMAGES}")
    SET_SOURCE_FILES_PROPERTIES(${MACOS_RESOURCES} PROPERTIES
        MACOSX_PACKAGE_LOCATION "Resources")
    SET(MOONPHASEQT_FILES "${MOONPHASEQT_FILES}" "${MACOS_RESOURCES}")

    # Bundle data.
    SET(MACOSX_BUNDLE_BUNDLE_NAME "${PROJECT_NAME} Bundle")
#    SET(MACOSX_BUNDLE_GUI_IDENTIFIER "${PROJECT_NAME} GUI ID" )
    SET(MACOSX_BUNDLE_ICON_FILE "${MOONPHASEQT_EXECUTABLENAME}.icns" )
    SET(MACOSX_BUNDLE_INFO_STRING "${MOONPHASE_DESCRIPTION}")
    SET(MACOSX_BUNDLE_SHORT_VERSION_STRING
        "${MOONPHASE_MAJORVERSION}.${MOONPHASE_MINORVERSION}")
    SET(MACOSX_BUNDLE_LONG_VERSION_STRING
        "${MACOSX_BUNDLE_SHORT_VERSION_STRING}.${MOONPHASE_PATCHVERSION}")
    SET(MACOSX_BUNDLE_BUNDLE_VERSION
        "${MOONPHASE_MAJORVERSION}.${MOONPHASE_MINORVERSION}.${MOONPHASE_PATCHVERSION}")
    SET(MACOSX_BUNDLE_COPYRIGHT "${MOONPHASE_COPYRIGHTNOTICE}")
    SET(MACOSX_BUNDLE_HIDEFROMDOCK true)  # Used in custom Info.plist.
  ENDIF()
ENDIF()


#
# Binaries
#

IF(OPTION_MOONPHASE_BUILDMOONPHASEQT)
  # moonphase-qt depends on an external library that is built from source code.
  IF(UNIX)
    SET(BUILD_COMMAND "$(MAKE)")
    SET(GUI_TYPE )
    SET(WWWIDGETS_LIBRARYPATHNAME ".")
    SET(OS_LIBRARIES m)
    IF(CMAKE_SYSTEM_NAME STREQUAL Darwin)
      SET(GUI_TYPE MACOSX_BUNDLE)
      FIND_LIBRARY(COREFOUNDATIONFRAMEWORK CoreFoundation)
      IF(COREFOUNDATIONFRAMEWORK-NOTFOUND)
        MESSAGE(ERROR "CoreFoundation framework not found.")
      ENDIF()
      FIND_LIBRARY(SYSTEMCONFIGURATIONFRAMEWORK SystemConfiguration)
      IF(COREFOUNDATIONFRAMEWORK-NOTFOUND)
        MESSAGE(ERROR "SystemConfiguration framework not found.")
      ENDIF()
      FIND_LIBRARY(SECURITYFRAMEWORK Security)
      IF(COREFOUNDATIONFRAMEWORK-NOTFOUND)
        MESSAGE(ERROR "Security framework not found.")
      ENDIF()
      SET(OS_LIBRARIES ${OS_LIBRARIES}
          ${COREFOUNDATIONFRAMEWORK}
          ${SYSTEMCONFIGURATIONFRAMEWORK}
          ${SECURITYFRAMEWORK})
    ENDIF()
  ELSEIF(MSVC)
    SET(BUILD_COMMAND nmake)
    SET(GUI_TYPE WIN32)
    SET(WWWIDGETS_LIBRARYPATHNAME "${BUILDTYPELC}")
    SET(OS_LIBRARIES imm32.lib winmm.lib ws2_32.lib ${QT_QTMAIN_LIBRARY})
  ENDIF()
  SET(WWWIDGETS_LIBRARYPATHNAME
      "${WWWIDGETS_LIBRARYPATHNAME}/${CMAKE_STATIC_LIBRARY_PREFIX}wwwidgets4")
  IF(MSVC)
    IF("${BUILDTYPELC}" STREQUAL "debug")
      SET(WWWIDGETS_LIBRARYPATHNAME "${WWWIDGETS_LIBRARYPATHNAME}d")
    ENDIF()
  ENDIF()
  SET(WWWIDGETS_LIBRARYPATHNAME
      "${WWWIDGETS_LIBRARYPATHNAME}${CMAKE_STATIC_LIBRARY_SUFFIX}")
  EXTERNALPROJECT_ADD(wwwidgets
      URL "http://www.wysota.eu.org/wwwidgets/wwWidgets-1.0.tar.gz"
      URL_HASH MD5=e8f8cbe75ee409f18ba44f786bcc438c
      DOWNLOAD_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../wwwidgets/"
      SOURCE_DIR "${CMAKE_BINARY_DIR}/wwwidgets/"
      BINARY_DIR "${CMAKE_BINARY_DIR}/wwwidgets/"
      PATCH_COMMAND COMMAND patch --binary -p1 -i
          "${CMAKE_CURRENT_SOURCE_DIR}/../wwwidgets/01-dont_build_plugins.patch"
      PATCH_COMMAND COMMAND patch --binary -p1 -i
          "${CMAKE_CURRENT_SOURCE_DIR}/../wwwidgets/02-dont_build_all_widgets.patch"
      PATCH_COMMAND COMMAND patch --binary -p1 -i
          "${CMAKE_CURRENT_SOURCE_DIR}/../wwwidgets/03-g++_-fvisibility=hidden.patch"
        # --binary switches are needed by Windows GNU diff.
      CONFIGURE_COMMAND ${QT_QMAKE_EXECUTABLE} "CONFIG+=staticlib ${BUILDTYPELC}"
      BUILD_COMMAND ${BUILD_COMMAND}
      INSTALL_COMMAND "")

  # Create the executable
  ADD_EXECUTABLE(
      ${MOONPHASEQT_EXECUTABLENAME} ${GUI_TYPE}
      ${COMMON_FILES}
      ${MOONPHASEQT_FILES})
  TARGET_LINK_LIBRARIES(
      ${MOONPHASEQT_EXECUTABLENAME}
      awisetoolboxqtutilities
      awisetoolboxqtwidgets
      awisetoolboxgeneric
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/${WWWIDGETS_LIBRARYPATHNAME}"
      ${OS_LIBRARIES}
      ${QT_LIBRARIES})
  ADD_DEPENDENCIES(${MOONPHASEQT_EXECUTABLENAME} wwwidgets)
  IF(APPLE)
    # Custom Info.plist.
    SET_TARGET_PROPERTIES(${MOONPHASEQT_EXECUTABLENAME} PROPERTIES
        MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/macos/Info.plist.in")
  ENDIF()

  # Set up for cpack.
  IF(BUILDRELEASEFLAG)
    IF(MSVC)
      # Options for the NSIS generator.
      INCLUDE("${CMAKE_CURRENT_LIST_DIR}/windows/nsis.cmake")
      INCLUDE(CPack)
    ELSEIF(APPLE)
      # Options for the DragNDrop generator.
      INCLUDE("${CMAKE_CURRENT_LIST_DIR}/macos/dragndrop.cmake")
      INCLUDE(CPack)
    ELSEIF(UNIX)
      # Debian and Fedora are not handled by CPack.
    ELSE()
      MESSAGE(FATAL_ERROR "Unknown release configuration. CMakeLists.txt needs to be updated!")
    ENDIF()
  ENDIF()
ENDIF()

# Build the library documentation.
IF(OPTION_MOONPHASE_BUILDMOONPHASEQTDOCUMENTATION)
  ADD_CUSTOM_TARGET(doc-${MOONPHASEQT_EXECUTABLENAME} ALL
      COMMAND ${DOXYGEN_EXECUTABLE}
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${MOONPHASEQT_EXECUTABLENAME}"
      SOURCES
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${MOONPHASEQT_EXECUTABLENAME}")
ENDIF()


#
# Subdirectories
#


#
# Installation
#

IF(OPTION_MOONPHASE_BUILDMOONPHASEQT)
  # Install information.
  IF(UNIX AND NOT APPLE)
    SET(INSTALL_BINARYDIRECTORY "bin/")
    SET(INSTALL_IMAGEDIRECTORY "share/${MOONPHASEQT_EXECUTABLENAME}")
  ELSEIF(WIN32 OR APPLE)
    SET(INSTALL_BINARYDIRECTORY "./")
    SET(INSTALL_IMAGEDIRECTORY "./")
  ENDIF()
  # Install executable.
  INSTALL(TARGETS "${MOONPHASEQT_EXECUTABLENAME}"
      RUNTIME DESTINATION ${INSTALL_BINARYDIRECTORY}
      BUNDLE DESTINATION ${INSTALL_BINARYDIRECTORY})
  IF(UNIX AND NOT APPLE)
    # Install any images.
    INSTALL(FILES ${MOONPHASE_IMAGES} DESTINATION ${INSTALL_IMAGEDIRECTORY})
    # Install an icon.
    INSTALL(FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/resources/${MOONPHASEQT_EXECUTABLENAME}.png"
        DESTINATION share/icons/)
    # Install the desktop file.
    INSTALL(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/${MOONPHASEQT_EXECUTABLENAME}.desktop"
        DESTINATION share/applications/)
    # Install the man page.
    INSTALL(FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/man/${MOONPHASEQT_EXECUTABLENAME}.1"
        DESTINATION share/man/man1/)
  ELSEIF(WIN32)

=== awisetoolbox/qt/designer/CMakeLists.txt ===
#
# CMakeLists.txt
# CMake makefile for the A.Wise Toolbox Qt Designer plugin.
#

#
# This file is part of awisetoolbox.
# Copyright (C) 2008-2017 by Alan Wise (awisesoftware@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# Display name.
SET(DISPLAYNAME "Qt Designer Plugin")

# Build information.
SET(LIBRARYNAME "${AWISETOOLBOX_BASENAME}qtplugin")
SET(MAJORVERSION ${AWISETOOLBOX_MAJORVERSION})
SET(MINORVERSION ${AWISETOOLBOX_MINORVERSION})
SET(PATCHVERSION ${AWISETOOLBOX_PATCHVERSION})
SET(DESCRIPTION
    "A Qt Designer plugin for ${AWISETOOLBOX_DISPLAYNAME} custom widgets.")
STRING(REPLACE ";" "" DESCRIPTION "${DESCRIPTION}")

# Directories.
SET(CMAKE_DIR "${PROJECT_SOURCE_DIR}/qt/designer/cmake/")
SET(FORMS_DIR "${PROJECT_SOURCE_DIR}/qt/designer/forms/")
SET(RESOURCES_DIR "${PROJECT_SOURCE_DIR}/qt/designer/resources/")
SET(SOURCES_DIR "${PROJECT_SOURCE_DIR}/qt/designer/sources/")


#
# Include paths
#


#
# Sources
#

IF(G_RELEASEFLAG)
  INCLUDE("cmake/documentation.cmake")
  INCLUDE("cmake/library.cmake")
  INCLUDE("cmake/test.cmake")
ENDIF()


#
# Binaries
#


#
# Subdirectories
#


#
# Installation
#


#
# CMakeLists.txt
#

=== awisetoolbox/qt/utilities/CMakeLists.txt ===
#
# CMakeLists.txt
# CMake makefile for the A.Wise Toolbox Qt Utilities library.
#

#
# This file is part of awisetoolbox.
# Copyright (C) 2008-2017 by Alan Wise (awisesoftware@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# Display name.
SET(DISPLAYNAME "Qt Utilities Library")

# Build information.
SET(LIBRARYNAME "${AWISETOOLBOX_BASENAME}qtutilities")
SET(MAJORVERSION ${AWISETOOLBOX_MAJORVERSION})
SET(MINORVERSION ${AWISETOOLBOX_MINORVERSION})
SET(PATCHVERSION ${AWISETOOLBOX_PATCHVERSION})
SET(DESCRIPTION
    "A Qt specific collection of code and data which can be used on"
    " multiple projects.")
STRING(REPLACE ";" "" DESCRIPTION "${DESCRIPTION}")

# Directories.
SET(CMAKE_DIR "${PROJECT_SOURCE_DIR}/qt/utilities/cmake/")
SET(FORMS_DIR "${PROJECT_SOURCE_DIR}/qt/utilities/forms/")
SET(RESOURCES_DIR "${PROJECT_SOURCE_DIR}/qt/utilities/resources/")
SET(SOURCES_DIR "${PROJECT_SOURCE_DIR}/qt/utilities/sources/")


#
# Include paths
#

SET(INCLUDE_DIRECTORIES
    "${PROJECT_SOURCE_DIR}/generic/sources/")
STRING(REPLACE ";" "\" \\\n\""
    TEMP_DOXYGEN_INCLUDE_PATHS "\"${INCLUDE_DIRECTORIES}\"")
STRING(CONCAT DOXYGEN_INCLUDE_PATHS
    "${DOXYGEN_INCLUDE_PATHS} \\\n${TEMP_DOXYGEN_INCLUDE_PATHS}")
INCLUDE_DIRECTORIES(
    "${INCLUDE_DIRECTORIES}")


#
# Sources
#

INCLUDE("cmake/documentation.cmake")
INCLUDE("cmake/library.cmake")
INCLUDE("cmake/test.cmake")


#
# Binaries
#


#
# Subdirectories
#


#
# Installation
#


#
# CMakeLists.txt
#

=== awisetoolbox/qt/widgets/CMakeLists.txt ===
#
# CMakeLists.txt
# CMake makefile for the A.Wise Toolbox Qt Widgets library.
#

#
# This file is part of awisetoolbox.
# Copyright (C) 2008-2017 by Alan Wise (awisesoftware@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# Display name.
SET(DISPLAYNAME "Qt Widgets Library")

# Build information.
SET(LIBRARYNAME "${AWISETOOLBOX_BASENAME}qtwidgets")
SET(MAJORVERSION ${AWISETOOLBOX_MAJORVERSION})
SET(MINORVERSION ${AWISETOOLBOX_MINORVERSION})
SET(PATCHVERSION ${AWISETOOLBOX_PATCHVERSION})
SET(DESCRIPTION
    "A Qt specific collection of code and data which can be used on"
    " multiple projects.")
STRING(REPLACE ";" "" DESCRIPTION "${DESCRIPTION}")

# Directories.
SET(CMAKE_DIR "${PROJECT_SOURCE_DIR}/qt/widgets/cmake/")
SET(FORMS_DIR "${PROJECT_SOURCE_DIR}/qt/widgets/forms/")
SET(RESOURCES_DIR "${PROJECT_SOURCE_DIR}/qt/widgets/resources/")
SET(SOURCES_DIR "${PROJECT_SOURCE_DIR}/qt/widgets/sources/")


#
# Include paths
#

SET(INCLUDE_DIRECTORIES )
STRING(REPLACE ";" "\" \\\n\""
    TEMP_DOXYGEN_INCLUDE_PATHS "\"${INCLUDE_DIRECTORIES}\"")
STRING(CONCAT DOXYGEN_INCLUDE_PATHS
    "${DOXYGEN_INCLUDE_PATHS} \\\n${TEMP_DOXYGEN_INCLUDE_PATHS}")
INCLUDE_DIRECTORIES( )


#
# Sources
#

INCLUDE("cmake/documentation.cmake")
INCLUDE("cmake/library.cmake")
INCLUDE("cmake/test.cmake")


#
# Binaries
#


#
# Subdirectories
#


#
# Installation
#


#
# CMakeLists.txt
#

=== debian/changelog ===
moonphase (0.5.0-1mx19+1) mx; urgency=medium

  * Rebuild for MX 19.
  * Bump debhelper compat to 9.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 13 Oct 2019 16:44:21 -0700

moonphase (0.5.0-1mx17+1) mx; urgency=medium

  * New release repackaged for MX 17.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 06 May 2018 07:04:20 -0700

=== debian/control ===
Source: moonphase
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mike Purtell (mmikeinsantarosa) <maintainer@mepiscommunity.org>
Build-Depends: debhelper (>= 9),
 cmake (>= 2.8),
 libqt4-dev
Standards-Version: 3.9.4
Homepage: http://moonphase.sourceforge.net/
Vcs-Git: https://gitlab.com/moonphase/moonphase
#Vcs-Browser: http://sourceforge.net/p/moonphase/code/ci/master/tree/

Package: moonphase-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Displays the phase of the moon in the system tray.
 Displays the phase of the moon in the system tray. Additionally, a window
 can be displayed that shows user selectable data about the moon
 (rise/set times, percent illumination, etc).
